\documentclass[a4paper,notitlepage,oneside,]{article}
\usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
\begin{document}
\frenchspacing
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 3a - Comparing Received Prefixes}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
\title{Experiment 3a - Comparing Received Prefixes}
\date{Version 1.3 - Teachers Copy - \today}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\maketitle
\section{Introduction}
This document is for the teacher. It outlines the Experiment 03 series - sending prefixes to the participants and have them figure out why one of them ist ``best''.

\section{Network Setup}
\begin{figure}[htp]
  \includegraphics[width=\linewidth,page=6]{../../img/Drawings.pdf}
  \caption{Network Setup}
  \label{fig:networksetup}
\end{figure}
Figure \ref{fig:networksetup} shows the network topology for this experiment.
It is the same as for experiment 2.
All participants are using AS64501 upwards and are connected to AS65550, AS64496 (and if required to AS286 for peering).

\section{Setup}
\subsection{Docker}
Remark: Instead of \emph{-n 5} use the number of students
\begin{verbatim}
  sudo mkfifo /run/exabgp.{in,out}
  sudo chmod 666 /run/exabgp.*
  cd experiment-03
  ./create-docker-compose -n 5 > docker-compose.yml
  docker-compose up &
  exabgp exabgp.conf &
  ./ex-01-localpref
  ...
\end{verbatim}

Important: when complete tear down Docker setup
\begin{verbatim}
  docker-compose down
\end{verbatim}


\section{Experiments}
\subsection{Local Preference}
Send one prefix over all three connections with the longest AS path on the peering connection.
\begin{description}
  \item[Command:] \texttt{./ex-01-localpref}
  \item[Result:] Peering prefix is best as because of local preference
  \item[Questions:]
  \begin{itemize}
    \item Which prefix announcement is best?
    \item Why? (which attribute decides)
    \item How is IP 129.13.0.1 routed?
  \end{itemize}
\end{description}

\subsection{AS Path length}
Announce a longer AS path through one upstream. Make it challenging so both paths have the same string length.
\begin{description}
  \item[Command:] \texttt{./ex-02-pathlength1}
  \item[Result:] Path with 3 ASes is best
\end{description}

\subsection{Origin Attribute}
Announce with ``EGP'',``IGP'' and ``incomplete'' Attributes.
\begin{description}
  \item[Command:] \texttt{./ex-03-origin}
  \item[Result:] IGP over EGP over incomplete
  \item[Explain:] What do these origins actually mean?
  \begin{description}
    \item[IGP:] Route is generated by a BGP \emph{network} statement.
    \item[EGP:] Route is received from EGP (Exterior Gateway Protocol - the predecessor of BGP which is no longer in use)
    \item[incomplete:] Route was redistributed from another protocol. This includes ``static''.
  \end{description}
  \item[Discuss:] Does it make sense to manually force this attribute? Incoming? Outgoing?
  \item[Task:] Change incoming the origin-type attribute to ``incomplete''.
\end{description}

\subsection{MED - Mult Exit Discriminator}
Announce prefix with differen MED. Show that MED is compared only when first AS in path is the same.
\begin{description}
  \item[Command:] \texttt{./ex-04a-med} + \texttt{./ex-04b-med} 
  \item[Result:] Lowest MED wins, but only if first AS in path is the same
  \item[Task 1:] Have them configure \emph{bgp always-compare-med} and check the bgp table
  \item[Task 2:] Show that missing MED is treated best. Have them configure \emph{bgp bestpath med missing-as-worst}.
\end{description}
Remark: Outgoing, if you do not intend to use MED with a customer or upstream provider, its best to simply set all MEDs to zero. This avoids being downrated if the other side has either \emph{always-compare-med} or \emph{missing-as-worst} configured.

\subsection{eBGP over iBGP}

\subsection{Nearest exit wins}

\subsection{Older (more stable) route wins}
Announce two routes to the same prefix. Withdraw the ``best'' one. Re-announce.
\begin{description}
  \item[Command:] \texttt{./ex-07-older}
  \item[Result:] When re-announcing withdrawn prefix ``best'' does not switch back.
  \item[Remark:] This only happens when comparing eBGP routes.
\end{description}

\subsection{Own prefix in path}
One announcement has the downstreams own AS (well, all of them) in the AS path and is not accepted. Have them use ``show ip bgp neighbor x.x.x.x received-routes'' to figure this out.
\begin{description}
  \item[Command:] \texttt{./ex-08-ownAS}
  \item[Result:] Only one prefix announcement is seen with all usual commands
  \item[Question:] Two prefixes are announced. Which ones? Why does your router only accept one of them?
\end{description}


\subsection{More specific}
Have one upstream connection announce a /24 instead of a /16.
\begin{description}
  \item[Command:] \texttt{./ex-09-morespecific}
  \item[Result:] Peering prefix is best /16 but there is also a /24
  \item[Questions:]
  \begin{itemize}
    \item Which prefix announcement is best?
    \item Why? (which attribute decides)
    \item How is IP 129.13.0.1 routed?
  \end{itemize}
\end{description}

\end{document}
